// To compile JNI library use the script file.
// For Linux 32-bit use file:
// compile32.sh
// For Linux 64-bit use file:
// compile64.sh


#include <stdio.h>
#include <dlfcn.h>



#include <string.h>



#include "WSQ_library_jniexport.h"




void* handle = NULL;
//handle = dlopen(filename_with_full_path_of_WSQ_library, RTLD_LAZY); // open shared library;
char* error;



//error = dlerror();
//if(error) { printf("%s\n", error); exit(1) };

//handle = dlopen(filename_with_full_path_of_WSQ_library, RTLD_LAZY); // open shared library


//void (*printer)(void);
//printer = dlsym(handle, "b_printer");
//if(error) { prinf("%s\n", error); exit(1) };

//printer(); //call funtion

//dlclose(handle);// close the shared library


unsigned char* wsq_comment_text = (unsigned char*)NULL;




typedef void (*_RegisterWSQ)();
_RegisterWSQ RegisterWSQ = 0;

typedef void (*_ShowFileConverter)();
_ShowFileConverter ShowFileConverter = 0;

typedef int (*_ReadImageFromFile)(const char*, int*, int*, unsigned char**);
_ReadImageFromFile ReadImageFromFile = 0;

typedef int (*_SaveImageToFile)(const char*, int, int, int, unsigned char*);
_SaveImageToFile SaveImageToFile = 0;

typedef void (*_WriteWSQ_bitrate)(double);
_WriteWSQ_bitrate WriteWSQ_bitrate = 0;

typedef double (*_ReadWSQ_bitrate)();
_ReadWSQ_bitrate ReadWSQ_bitrate = 0;

typedef void (*_WriteWSQ_ppi)(int);
_WriteWSQ_ppi WriteWSQ_ppi = 0;

typedef int (*_ReadWSQ_ppi)();
_ReadWSQ_ppi ReadWSQ_ppi = 0;

typedef void (*_WriteWSQ_comment)(char*);
_WriteWSQ_comment WriteWSQ_comment = 0;

typedef char* (*_ReadWSQ_comment)();
_ReadWSQ_comment ReadWSQ_comment = 0;

typedef void (*_WriteTIFFcompression)(int);
 _WriteTIFFcompression WriteTIFFcompression = 0;

typedef void (*_WriteTIFFpredictor)(int);
_WriteTIFFpredictor WriteTIFFpredictor = 0;

typedef void (*_SetShowFilePropertiesDialog)(int);
_SetShowFilePropertiesDialog SetShowFilePropertiesDialog = 0;


typedef int (*_WSQ_decode_stream)(unsigned char *input_data_stream, const int
input_stream_length, unsigned char **output_data_stream, int *width, int
*height, int *ppi, unsigned char **comment_text);
_WSQ_decode_stream WSQ_decode_stream = 0;


typedef int (*_WSQ_encode_stream)
(unsigned char *input_data_stream, const int width, const int height, const double bitrate,
const int ppi, char *comment_text, unsigned char **output_data_stream, int *output_stream_length);
_WSQ_encode_stream WSQ_encode_stream = 0;


typedef char*(*_GenerateSerialNumber)();
_GenerateSerialNumber GenerateSerialNumber = 0;

typedef int (*_UnlockWSQLibrary)(const char* authorization_code);
_UnlockWSQLibrary UnlockWSQLibrary = 0;



JNIEXPORT jstring JNICALL Java_wsq_1sun_1java_WSQ_1Demo_GenerateSerialNumber(JNIEnv * env, jclass)
{
       if(handle == NULL)
       {
         handle = dlopen(filename_with_full_path_of_WSQ_library, RTLD_LAZY); // open shared library;
         if(handle == NULL){fputs(dlerror(), stderr); return NULL;}
       }

	if (!GenerateSerialNumber) 
        {
          GenerateSerialNumber = (_GenerateSerialNumber)dlsym(handle, "GenerateSerialNumber");
          if(GenerateSerialNumber == NULL){fputs(dlerror(), stderr); return NULL;}
	}


	const char* serial_number_char = GenerateSerialNumber();
	jstring serial_number = env->NewStringUTF(serial_number_char);

	return serial_number;
}


JNIEXPORT jint JNICALL Java_wsq_1sun_1java_WSQ_1Demo_UnlockWSQLibrary(JNIEnv * env, jclass,  jstring authorization_code)
{
       if(handle == NULL)
       {
         handle = dlopen(filename_with_full_path_of_WSQ_library, RTLD_LAZY); // open shared library;
         if(handle == NULL){fputs(dlerror(), stderr); return 0;}
       }

	if (!UnlockWSQLibrary) 
        {
          UnlockWSQLibrary = (_UnlockWSQLibrary)dlsym(handle, "UnlockWSQLibrary");
          if(UnlockWSQLibrary == NULL){fputs(dlerror(), stderr); return 0;}
	}

	const char* authorization_code_char = env->GetStringUTFChars(authorization_code, 0);


	return (jint)UnlockWSQLibrary(authorization_code_char);


}


//=============




JNIEXPORT void JNICALL Java_wsq_1sun_1java_WSQ_1Demo_RegisterWSQ(JNIEnv *, jclass)
{

       if(handle == NULL)
       {
         handle = dlopen(filename_with_full_path_of_WSQ_library, RTLD_LAZY); // open shared library;
         if(handle == NULL){fputs(dlerror(), stderr); return;}
       }

	if (!RegisterWSQ) 
        {
          RegisterWSQ = (_RegisterWSQ)dlsym(handle, "RegisterWSQ");
          if(RegisterWSQ == NULL){fputs(dlerror(), stderr); return;}
	}

	RegisterWSQ();
}

JNIEXPORT void JNICALL Java_wsq_1sun_1java_WSQ_1Demo_ShowFileConverter(JNIEnv *, jclass)
{

       if(handle == NULL)
       {
         handle = dlopen(filename_with_full_path_of_WSQ_library, RTLD_LAZY); // open shared library;
         if(handle == NULL){fputs(dlerror(), stderr); return;}
       }

	if (!ShowFileConverter) 
        {
          ShowFileConverter = (_ShowFileConverter)dlsym(handle, "ShowFileConverter");
          if(ShowFileConverter == NULL){fputs(dlerror(), stderr); return;}
	}


	ShowFileConverter();
}

JNIEXPORT jintArray JNICALL Java_wsq_1sun_1java_WSQ_1Demo_ReadImageFromFile(JNIEnv* env, jclass, jintArray imageDimension, jstring fileName)
{

       if(handle == NULL)
       {
         handle = dlopen(filename_with_full_path_of_WSQ_library, RTLD_NOW); // open shared library;
         if(handle == NULL){fputs(dlerror(), stderr); return NULL;}
       }

	if (!ReadImageFromFile) 
        {
          ReadImageFromFile = (_ReadImageFromFile)dlsym(handle, "ReadImageFromFile");
          if(ReadImageFromFile == NULL){fputs(dlerror(), stderr); return NULL;}
	}



//error = dlerror();
/*
//==================================
FILE *outfp;
int n, ret, fsize;
   char* license_file = "/home/knoppix/Desktop/WSQ_Sun_Java_Linux/klaida.txt";

   if((outfp = fopen(license_file, "wb")) != (FILE *)NULL)
   {
//   n = fwrite(error, sizeof(unsigned char), sizeof(error), outfp);
//   n = fwrite("valio ok", sizeof(unsigned char), 8, outfp);
   }//if((infp = fopen(ifile, "rb")) != (FILE *)NULL)


n = fwrite("valio ok", sizeof(unsigned char), 8, outfp);

   fclose(outfp);
//==================================
*/




	const char* file = env->GetStringUTFChars(fileName, 0);
	
	int width = 0;
	int height = 0;
	unsigned char* imageData = 0;

	ReadImageFromFile(file, &width, &height, &imageData);






	
	jboolean isDimensionCopy = JNI_FALSE;
	
	jint* dimension = (jint *)env->GetPrimitiveArrayCritical(imageDimension, &isDimensionCopy);
	dimension[0] = width;
	dimension[1] = height;
	env->ReleasePrimitiveArrayCritical(imageDimension, dimension, JNI_ABORT);

	jboolean isCopy = true;
	jintArray pixels = env->NewIntArray(width * height);
	jint *pixel = (jint *)env->GetPrimitiveArrayCritical(pixels, &isCopy);

	int number_of_pixels = width*height;
	for (int index = 0; index < width*height; index++) {
//	pixel[index] = (imageData[index] << 16) | (imageData[index+number_of_pixels] << 8) | (imageData[index+2*number_of_pixels]);

		pixel[index] = ((int)imageData[index] << 16) | ((int)imageData[index+number_of_pixels] << 8) | ((int)imageData[index+2*number_of_pixels]);
	}

	env->ReleasePrimitiveArrayCritical(pixels, pixel, JNI_ABORT);
	return pixels;
}

JNIEXPORT void JNICALL Java_wsq_1sun_1java_WSQ_1Demo_SaveImageToFile(JNIEnv* env, jclass, jintArray pixels, jint width, jint height, jstring fileName, jint type)
{

       if(handle == NULL)
       {
         handle = dlopen(filename_with_full_path_of_WSQ_library, RTLD_LAZY); // open shared library;
         if(handle == NULL){fputs(dlerror(), stderr); return;}
       }

	if (!SaveImageToFile) 
        {
          SaveImageToFile = (_SaveImageToFile)dlsym(handle, "SaveImageToFile");
          if(SaveImageToFile == NULL){fputs(dlerror(), stderr); return;}
	}



	jboolean isCopy = JNI_FALSE;
	jint* pixel = (jint *)env->GetPrimitiveArrayCritical(pixels, &isCopy);
	const char* file = env->GetStringUTFChars(fileName, 0);

	int* p = pixel;
	unsigned char* imageData = new unsigned char[width*height*3];

	int number_of_pixels = width*height;
	
	for (int index = 0; index < width*height; index++) {
//		*(imageData+index) = qRed(*(p+index));
//		*(imageData+index+number_of_pixels) = qGreen(*(p+index));
//		*(imageData+index+2*number_of_pixels) = qBlue(*(p+index));

		*(imageData+index) = (unsigned char)((((int)p[index])>>16) & 0x000Ff);
		*(imageData+index+number_of_pixels) = (unsigned char)((((int)p[index])>>8) & 0x000Ff);
		*(imageData+index+2*number_of_pixels) = (unsigned char)((int)p[index] & 0x000Ff);

	}

	SaveImageToFile(file, type, width, height, imageData);

	env->ReleasePrimitiveArrayCritical(pixels, pixel, JNI_ABORT);
}

JNIEXPORT void JNICALL Java_wsq_1sun_1java_WSQ_1Demo_WriteWSQ_1bitrate(JNIEnv *, jclass, jdouble bitrate)
{

       if(handle == NULL)
       {
         handle = dlopen(filename_with_full_path_of_WSQ_library, RTLD_LAZY); // open shared library;
         if(handle == NULL){fputs(dlerror(), stderr); return;}
       }

	if (!WriteWSQ_bitrate) 
        {
          WriteWSQ_bitrate = (_WriteWSQ_bitrate)dlsym(handle, "WriteWSQ_bitrate");
          if(WriteWSQ_bitrate == NULL){fputs(dlerror(), stderr); return;}
	}


	WriteWSQ_bitrate(bitrate);
}

JNIEXPORT jdouble JNICALL Java_wsq_1sun_1java_WSQ_1Demo_ReadWSQ_1bitrate(JNIEnv* env, jclass)
{

       if(handle == NULL)
       {
         handle = dlopen(filename_with_full_path_of_WSQ_library, RTLD_LAZY); // open shared library;
         if(handle == NULL){fputs(dlerror(), stderr); return -1.0;}
       }


	if (!ReadWSQ_bitrate) 
        {
          ReadWSQ_bitrate = (_ReadWSQ_bitrate)dlsym(handle, "ReadWSQ_bitrate");
          if(ReadWSQ_bitrate == NULL){fputs(dlerror(), stderr); return -1.0;}
	}



	double d = ReadWSQ_bitrate();
	jdouble jd = d;
	return jd;
}

JNIEXPORT void JNICALL Java_wsq_1sun_1java_WSQ_1Demo_WriteWSQ_1ppi(JNIEnv *, jclass, jint ppi)
{

       if(handle == NULL)
       {
         handle = dlopen(filename_with_full_path_of_WSQ_library, RTLD_LAZY); // open shared library;
         if(handle == NULL){fputs(dlerror(), stderr); return;}
       }


	if (!WriteWSQ_ppi) 
        {
          WriteWSQ_ppi = (_WriteWSQ_ppi)dlsym(handle, "WriteWSQ_ppi");
          if(WriteWSQ_ppi == NULL){fputs(dlerror(), stderr); return;}
	}	


	WriteWSQ_ppi(ppi);
}

JNIEXPORT jint JNICALL Java_wsq_1sun_1java_WSQ_1Demo_ReadWSQ_1ppi(JNIEnv *, jclass)
{
	
       if(handle == NULL)
       {
         handle = dlopen(filename_with_full_path_of_WSQ_library, RTLD_LAZY); // open shared library;
         if(handle == NULL){fputs(dlerror(), stderr); return -1;}
       }

	if (!ReadWSQ_ppi) 
        {
          ReadWSQ_ppi = (_ReadWSQ_ppi)dlsym(handle, "ReadWSQ_ppi");
          if(ReadWSQ_ppi == NULL){fputs(dlerror(), stderr); return -1;}
	}	
	

	int ppi = ReadWSQ_ppi();
	return ppi;
}

JNIEXPORT void JNICALL Java_wsq_1sun_1java_WSQ_1Demo_WriteWSQ_1comment(JNIEnv* env, jclass, jstring comment)
{

       if(handle == NULL)
       {
         handle = dlopen(filename_with_full_path_of_WSQ_library, RTLD_LAZY); // open shared library;
         if(handle == NULL){fputs(dlerror(), stderr); return;}
       }


	if (!WriteWSQ_comment) 
        {
          WriteWSQ_comment = (_WriteWSQ_comment)dlsym(handle, "WriteWSQ_comment");
          if(WriteWSQ_comment == NULL){fputs(dlerror(), stderr); return;}
	}	
	

	const char* com = env->GetStringUTFChars(comment, 0);
	char* c = const_cast<char*> (com);
	WriteWSQ_comment(c);
}

JNIEXPORT jstring JNICALL Java_wsq_1sun_1java_WSQ_1Demo_ReadWSQ_1comment(JNIEnv* env, jclass)
{


       if(handle == NULL)
       {
         handle = dlopen(filename_with_full_path_of_WSQ_library, RTLD_LAZY); // open shared library;
         if(handle == NULL){fputs(dlerror(), stderr); return NULL;}
       }	


	if (!ReadWSQ_comment) 
        {
          ReadWSQ_comment = (_ReadWSQ_comment)dlsym(handle, "ReadWSQ_comment");
          if(ReadWSQ_comment == NULL){fputs(dlerror(), stderr); return NULL;}
	}
	
	const char* comment = ReadWSQ_comment();
	jstring com = env->NewStringUTF(comment);
	return com;
}

JNIEXPORT void JNICALL Java_wsq_1sun_1java_WSQ_1Demo_WriteTIFFcompression(JNIEnv *, jclass, jint compression)
{

       if(handle == NULL)
       {
         handle = dlopen(filename_with_full_path_of_WSQ_library, RTLD_LAZY); // open shared library;
         if(handle == NULL){fputs(dlerror(), stderr); return;}
       }

	if (!WriteTIFFcompression) 
        {
          WriteTIFFcompression = (_WriteTIFFcompression)dlsym(handle, "WriteTIFFcompression");
          if(WriteTIFFcompression == NULL){fputs(dlerror(), stderr); return;}
	}



	WriteTIFFcompression(compression);
}

JNIEXPORT void JNICALL Java_wsq_1sun_1java_WSQ_1Demo_WriteTIFFpredictor(JNIEnv *, jclass, jint predict)
{


       if(handle == NULL)
       {
         handle = dlopen(filename_with_full_path_of_WSQ_library, RTLD_LAZY); // open shared library;
         if(handle == NULL){fputs(dlerror(), stderr); return;}
       }



	if (!WriteTIFFpredictor) 
        {
          WriteTIFFpredictor = (_WriteTIFFpredictor)dlsym(handle, "WriteTIFFpredictor");
          if(WriteTIFFpredictor == NULL){fputs(dlerror(), stderr); return;}
	}


	WriteTIFFpredictor(predict);


}

JNIEXPORT void JNICALL Java_wsq_1sun_1java_WSQ_1Demo_SetShowFilePropertiesDialog(JNIEnv *, jclass, jint file_properties_dialog)
{


       if(handle == NULL)
       {
         handle = dlopen(filename_with_full_path_of_WSQ_library, RTLD_LAZY); // open shared library;
         if(handle == NULL){fputs(dlerror(), stderr); return;}
       }
	

	if (!SetShowFilePropertiesDialog) 
        {
          SetShowFilePropertiesDialog = (_SetShowFilePropertiesDialog)dlsym(handle, "SetShowFilePropertiesDialog");
          if(SetShowFilePropertiesDialog == NULL){fputs(dlerror(), stderr); return;}
	}


	SetShowFilePropertiesDialog(file_properties_dialog);
}



JNIEXPORT jbyteArray JNICALL Java_wsq_1sun_1java_WSQ_1Demo_WSQ_1decode_1stream(JNIEnv *env, jclass, jbyteArray input, jintArray imageProperties)
{


       if(handle == NULL)
       {
         handle = dlopen(filename_with_full_path_of_WSQ_library, RTLD_LAZY); // open shared library;
         if(handle == NULL){fputs(dlerror(), stderr); return NULL;}
       }
	

	if (!WSQ_decode_stream) 
        {
          WSQ_decode_stream = (_WSQ_decode_stream)dlsym(handle, "WSQ_decode_stream");
          if(WSQ_decode_stream == NULL){fputs(dlerror(), stderr); return NULL;}
	}


	jsize input_stream_length = env->GetArrayLength(input);

	jboolean isCopy = JNI_FALSE;
	jbyte * input_data_stream = env->GetByteArrayElements(input, &isCopy);

	int width = 0, height = 0, ppi = 0;
        wsq_comment_text = (unsigned char*)NULL;
	unsigned char * output_data_stream;


	WSQ_decode_stream((unsigned char *)input_data_stream, input_stream_length,
		&output_data_stream, &width, &height, &ppi, &wsq_comment_text);


        if(wsq_comment_text != NULL)
	{
	 wsq_comment_text = (unsigned char*)NULL;
	}//if(wsq_comment_text != NULL)


	jbyteArray output = env->NewByteArray(width * height);
	env->ReleaseByteArrayElements(output, (signed char*)output_data_stream, 0);


	//jint dim[3] = { width, height, ppi };   <<-- BAD
        //env->ReleaseIntArrayElements(imageProperties, dim, 0);      <<-- BAD

	jboolean isDimensionCopy = JNI_FALSE;
	
	jint* dim = (jint *)env->GetPrimitiveArrayCritical(imageProperties, &isDimensionCopy);
	dim[0] = width;
	dim[1] = height;
        dim[2] = ppi;
	env->ReleasePrimitiveArrayCritical(imageProperties, dim, JNI_ABORT);	


	return output;

}



JNIEXPORT jbyteArray JNICALL Java_wsq_1sun_1java_WSQ_1Demo_WSQ_1encode_1stream
(JNIEnv *env, jclass, jbyteArray input, jint width, jint height, jdouble bitrate, jint ppi, jstring comment_text)
{

       if(handle == NULL)
       {
         handle = dlopen(filename_with_full_path_of_WSQ_library, RTLD_LAZY); // open shared library;
         if(handle == NULL){fputs(dlerror(), stderr); return NULL;}
       }
	

	if (!WSQ_encode_stream) 
        {
          WSQ_encode_stream = (_WSQ_encode_stream)dlsym(handle, "WSQ_encode_stream");
          if(WSQ_encode_stream == NULL){fputs(dlerror(), stderr); return NULL;}
	}


	unsigned char * output_data_stream;


	jboolean isCopy = JNI_FALSE;
	unsigned char* input_data_stream = (unsigned char*)env->GetByteArrayElements(input, &isCopy);

	wsq_comment_text = (unsigned char*)env->GetStringUTFChars(comment_text, NULL);

	int output_stream_length;

	WSQ_encode_stream(input_data_stream, width, height, bitrate, ppi, (char *)wsq_comment_text, &output_data_stream, &output_stream_length);

	jbyteArray output = env->NewByteArray(output_stream_length);
	env->ReleaseByteArrayElements(output, (signed char*)output_data_stream, 0);



	return output;

}




JNIEXPORT void JNICALL Java_wsq_1sun_1java_WSQ_1Demo_Set_1Path_1of_1WSQ_1library
  (JNIEnv *env, jclass, jstring path_of_WSQ_library)
{


filename_with_full_path_of_WSQ_library[0] = '\0';

strcat(filename_with_full_path_of_WSQ_library, env->GetStringUTFChars(path_of_WSQ_library, 0));


#ifdef __x86_64__
  strcat(filename_with_full_path_of_WSQ_library, "/libWSQ_library64.so");
#else
  strcat(filename_with_full_path_of_WSQ_library, "/libWSQ_library.so");
#endif


WSQ_library_path_is_set = 1;



}

